#include "LKH.h"

int main(int argc, char *argv[])
{
    GainType Cost;
    int *CGTour, *Used, Sub = 0, i, j;
    Node *From, *To;
    FILE *CGTourFile;
    char *CGTourFileName, *Line, *Keyword, Buf1[256], Buf2[256];
    char Delimiters[] = " :=\n\t\r\f\v\xef\xbb\xbf";

    /* Read the specification of the problem */

    Scale = 1;
    sprintf(Buf1, "INSTANCES/%s/%s.cgtsp", argv[1], argv[2]);
    ProblemFileName = Buf1;
    sprintf(Buf2, "CG-TOURS/%s/%s.%s.tour", argv[1], argv[2], argv[3]);
    CGTourFileName = Buf2;
    MaxMatrixDimension = 0;
    Scale = 1000;
    ReadProblem();
    ClusterArray = (Cluster *) calloc(Clusters + 1, sizeof(Cluster));
    for (i = 1; i <= DimensionSaved; i++) {
        From = &NodeSet[i];
        if (From->Subcluster > ClusterArray[From->Cluster].Size)
            ClusterArray[From->Cluster].Size = From->Subcluster;
    }
    for (j = 1; j <= Clusters; j++)
        ClusterArray[j].SubclusterArray = (Subcluster *)
            calloc(ClusterArray[j].Size + 1, sizeof(Subcluster));
    for (i = 1; i <= DimensionSaved; i++) {
        From = &NodeSet[i];
        ClusterArray[From->Cluster].
            SubclusterArray[From->Subcluster].Size++;
        if (!ClusterArray[From->Cluster].
                SubclusterArray[From->Subcluster].First)
            ClusterArray[From->Cluster].
                SubclusterArray[From->Subcluster].First =
            ClusterArray[From->Cluster].
                SubclusterArray[From->Subcluster].Last = From;
        ClusterArray[From->Cluster].
            SubclusterArray[From->Subcluster].Last->Next = From;
        From->Next =
            ClusterArray[From->Cluster].
                SubclusterArray[From->Subcluster].First;
        ClusterArray[From->Cluster].
            SubclusterArray[From->Subcluster].Last = From;
    }
    for (i = 1; i <= Clusters; i++) {
        for (j = 1; j <= ClusterArray[i].Size; j++) {
            Sub++;
            From = To = ClusterArray[i].SubclusterArray[j].First;
            do
                From->V = Sub;
            while ((From = From->Next) != To);
        }
    }
    if (Sub != Subclusters)
        eprintf("PROBLEM: Wrong number of subclusters");

    if (!(CGTourFile = fopen(CGTourFileName, "r")))
        eprintf("Cannot find %s\n", CGTourFileName);
    while ((Line = ReadLine(CGTourFile))) {
        if (!(Keyword = strtok(Line, Delimiters)))
            continue;
        for (i = 0; i < strlen(Keyword); i++)
            Keyword[i] = (char) toupper(Keyword[i]);
        if (!strcmp(Keyword, "TOUR_SECTION"))
            break;
        if (Optimum == 0 && !strcmp(Keyword, "COMMENT")) {
            Keyword = strtok(0, Delimiters);
            Keyword = strtok(0, Delimiters);
            Optimum = atol(Keyword);
        } else {
            if (!strcmp(Keyword, "DIMENSION")) {
                int n;
                Keyword = strtok(0, Delimiters);
                n = atoi(Keyword);
                if (n != Subclusters)
                    eprintf("G-TOUR: Wrong number of subclusters");
            }
        }
    }

    assert(CGTour = (int *) malloc((Subclusters + 1) * sizeof(int)));
    for (i = 1; i <= Subclusters; i++)
        fscanf(CGTourFile, "%d", &CGTour[i]);
    CGTour[0] = CGTour[Subclusters];
    assert(Used = (int *) calloc(Subclusters + 1, sizeof(int)));
    Cost = 0;
    for (i = 1; i <= Subclusters; i++) {
        Cost += ProblemType != ATSP ?
            Distance(&NodeSet[CGTour[i - 1]], &NodeSet[CGTour[i]]) :
            NodeSet[CGTour[i - 1]].C[CGTour[i]];
        if (Used[NodeSet[CGTour[i]].V])
            eprintf("G-TOUR: Subcluster entered more than once");
        Used[NodeSet[CGTour[i]].V] = 1;
    }
    for (i = 1; i <= Subclusters; i++)
        if (!Used[i])
            eprintf("G-TOUR: Unvisited subcluster(s)");
    for (i = 1; i <= Subclusters; i++)
        NodeSet[CGTour[i - 1]].Suc = &NodeSet[CGTour[i]];
    From = &NodeSet[CGTour[0]];
    i = From->Cluster;
    do
        From = From->Suc;
    while (From->Cluster == i);
    FirstNode = From;
    for (i = 1; i <= Clusters; i++)
        Used[i] = 0;
    do {
        i = From->Cluster;
        if (Used[i])
            eprintf("G-TOUR: Cluster %d entered more than once", i);
        Used[i] = 1;
        do
            From = From->Suc;
        while (From->Cluster == i);
    } while (From != FirstNode);
    for (i = 1; i <= Clusters; i++)
        if (!Used[i])
            eprintf("G-TOUR: Unvisited cluster(s)");
    if (Cost != Optimum)
        eprintf("Cost = %lld != Optimum = %lld\n", Cost, Optimum);
    printff("OK. Cost = %lld\n", Cost);
    free(Used);
    return 0;
}
